Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4501)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4502)
@@ -4632,4 +5695,184 @@
 
     END SUBROUTINE sedimentation_cloud_ij
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sedimentation of ice crystals
+!------------------------------------------------------------------------------!
+    SUBROUTINE sedimentation_ice
+
+       INTEGER(iwp) ::  i             !< loop index
+       INTEGER(iwp) ::  j             !< loop index
+       INTEGER(iwp) ::  k             !< loop index
+
+       REAL(wp) ::  flag              !< flag to indicate first grid level
+       REAL(wp) ::  av = 6.39_wp      !< parameter for calculating fall speed
+       REAL(wp) ::  bv = 0.1666_wp    !< parameter (1/6)
+       REAL(wp) ::  xi = 0.0_wp       !< mean mass of ice crystal
+       REAL(wp) ::  vi = 0.0_wp       !< mean fall speed of ice crystal
+       REAL(wp) ::  factor_sed_gamma_k0 = 0.76_wp !< factor for zeroth moment and
+                                                  !< Âµ =1/3 and nu=0
+       REAL(wp) ::  factor_sed_gamma_k1 = 1.61_wp !< factor for first moment and
+                                                  !< Âµ =1/3 and nu=0
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_ni  !< sedimentation rate zeroth moment
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_qi  !< sedimentation rate fist moment
+
+       CALL cpu_log( log_point_s(96), 'sed_ice', 'start' )
+
+       sed_qi(nzt+1) = 0.0_wp
+       sed_ni(nzt+1) = 0.0_wp
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzt, nzb+1, -1
+
+                IF ( ni(k,j,i) <= 0.0_wp ) THEN
+                   xi = 0.0_wp
+                ELSE
+!--                Calculate mean mass of ice crystal
+                   xi = MAX( (hyrho(k) * qi(k,j,i) / ni(k,j,i)), ximin)
+                ENDIF
+!
+!--             calculate fall speed of ice crystal
+                vi = av * xi**bv
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--             Calculate sedimentation rate for each grid box, factors are
+!--             calculated using
+                IF ( qi(k,j,i) > eps_sb  .AND.  ni(k,j,i) >= 0.0_wp )  THEN
+                   sed_qi(k) = qi(k,j,i) * vi * factor_sed_gamma_k1 * flag
+                   sed_ni(k) = ni(k,j,i) * vi * factor_sed_gamma_k0 * flag
+                ELSE
+                   sed_qi(k) = 0.0_wp
+                   sed_ni(k) = 0.0_wp
+                ENDIF
+!
+!--             Calculate sedimentation: divergence of sedimentation flux
+                sed_qi(k) = MIN( sed_qi(k), hyrho(k) * dzu(k+1) * q(k,j,i) /   &
+                                            dt_micro + sed_qi(k+1)             &
+                               ) * flag
+
+                q(k,j,i)  = q(k,j,i)  + ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1)&
+                                      / hyrho(k) * dt_micro * flag
+                qi(k,j,i) = qi(k,j,i) + ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1)&
+                                      / hyrho(k) * dt_micro * flag
+                ni(k,j,i) = ni(k,j,i) + ( sed_ni(k+1) - sed_ni(k) ) * ddzu(k+1)&
+                                      / hyrho(k) * dt_micro * flag
+
+                pt(k,j,i) = pt(k,j,i) - ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1)&
+                                      / hyrho(k) * l_s / c_p * d_exner(k) *    &
+                                        dt_micro * flag
+!
+!--             Compute the precipitation rate of cloud (fog) droplets
+                IF ( call_microphysics_at_all_substeps )  THEN
+                   prr(k,j,i) = prr(k,j,i) + sed_qi(k) / hyrho(k) *            &
+                                weight_substep(intermediate_timestep_count) *  &
+                                flag
+                ELSE
+                   prr(k,j,i) = prr(k,j,i) + sed_qi(k) / hyrho(k) * flag
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+       CALL cpu_log( log_point_s(96), 'sed_ice', 'stop' )
+
+    END SUBROUTINE sedimentation_ice
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sedimentation of ice crystals
+!------------------------------------------------------------------------------!
+    SUBROUTINE sedimentation_ice_ij( i, j )
+
+       INTEGER(iwp) ::  i             !<
+       INTEGER(iwp) ::  j             !<
+       INTEGER(iwp) ::  k             !<
+
+       REAL(wp) ::  flag           !< flag to indicate first grid level
+       REAL(wp) ::  av = 6.39_wp   !< parameter for calculating fall speed
+       REAL(wp) ::  bv = 0.1666_wp !<
+       REAL(wp) ::  xi = 0.0_wp    !< mean mass of ice crystal
+       REAL(wp) ::  vi = 0.0_wp    !< mean fall speed of ice crystal
+       REAL(wp) ::  factor_sed_gamma_k0 = 0.76_wp
+       REAL(wp) ::  factor_sed_gamma_k1 = 1.61_wp
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_ni  !<
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  sed_qi  !<
+
+       sed_qi(nzt+1) = 0.0_wp
+       sed_ni(nzt+1) = 0.0_wp
+
+       DO  k = nzt, nzb+1, -1
+          IF ( ni(k,j,i) <= 0.0_wp ) THEN
+             xi = 0.0_wp
+          ELSE
+!--          Calculate mean mass of ice crystal
+             xi = MAX( (hyrho(k) * qi(k,j,i) / ni(k,j,i)), ximin)
+          ENDIF
+!
+!--       calculate fall speed of ice crystal
+          vi = av * xi**bv
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+!
+!--       Calculate sedimentation rate for each grid box, factors are
+!--       calculated using
+          IF ( qi(k,j,i) > eps_sb  .AND.  ni(k,j,i) >= 0.0_wp )  THEN
+             sed_qi(k) = qi(k,j,i) * vi * factor_sed_gamma_k1 * flag
+             sed_ni(k) = ni(k,j,i) * vi * factor_sed_gamma_k0 * flag
+          ELSE
+             sed_qi(k) = 0.0_wp
+             sed_ni(k) = 0.0_wp
+          ENDIF
+!
+!--       calculate fall speed of ice crystal
+          vi = av * xi**bv
+!
+!--       Predetermine flag to mask topography
+          flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+
+          IF ( qi(k,j,i) > eps_sb  .AND.  ni(k,j,i) >= 0.0_wp )  THEN
+             sed_qi(k) = qi(k,j,i) * vi * factor_sed_gamma_k1 * flag
+             sed_ni(k) = ni(k,j,i) * vi * factor_sed_gamma_k0 * flag
+          ELSE
+             sed_qi(k) = 0.0_wp
+             sed_ni(k) = 0.0_wp
+          ENDIF
+
+          sed_qi(k) = MIN( sed_qi(k), hyrho(k) * dzu(k+1) * q(k,j,i) /         &
+                                      dt_micro + sed_qi(k+1)                   &
+                         ) * flag
+
+          q(k,j,i)  = q(k,j,i)  + ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1) /    &
+                                hyrho(k) * dt_micro * flag
+          qi(k,j,i) = qi(k,j,i) + ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1) /    &
+                                hyrho(k) * dt_micro * flag
+          ni(k,j,i) = ni(k,j,i) + ( sed_ni(k+1) - sed_ni(k) ) * ddzu(k+1) /    &
+                                hyrho(k) * dt_micro * flag
+          pt(k,j,i) = pt(k,j,i) - ( sed_qi(k+1) - sed_qi(k) ) * ddzu(k+1) /    &
+                                hyrho(k) * l_s / c_p * d_exner(k) * dt_micro   &
+                                                                  * flag
+!
+!--       Compute the precipitation rate of cloud (fog) droplets
+          IF ( call_microphysics_at_all_substeps )  THEN
+             prr(k,j,i) = prr(k,j,i) + sed_qi(k) / hyrho(k) *                  &
+                              weight_substep(intermediate_timestep_count) * flag
+          ELSE
+             prr(k,j,i) = prr(k,j,i) + sed_qi(k) / hyrho(k) * flag
+          ENDIF
+
+       ENDDO
+
+    END SUBROUTINE sedimentation_ice_ij
+
 
 
@@ -5053,5 +6296,5 @@
 
           sed_nr(k) = flux / dt_micro * flag
-          nr(k,j,i)  = nr(k,j,i) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /     &
+          nr(k,j,i)  = nr(k,j,i) + ( sed_nr(k+1) - sed_nr(k) ) * ddzu(k+1) /   &
                                     hyrho(k) * dt_micro * flag
 !
@@ -5080,9 +6323,9 @@
           sed_qr(k) = flux / dt_micro * flag
 
-          qr(k,j,i) = qr(k,j,i) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
+          qr(k,j,i) = qr(k,j,i) + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * dt_micro * flag
-          q(k,j,i)  = q(k,j,i)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
+          q(k,j,i)  = q(k,j,i)  + ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * dt_micro * flag
-          pt(k,j,i) = pt(k,j,i) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /      &
+          pt(k,j,i) = pt(k,j,i) - ( sed_qr(k+1) - sed_qr(k) ) * ddzu(k+1) /    &
                                 hyrho(k) * lv_d_cp * d_exner(k) * dt_micro     &
                                                                 * flag
@@ -5202,15 +6445,59 @@
 !--    (see: Cuijpers + Duynkerke, 1993, JAS, 23)
        q_s   = q_s * ( 1.0_wp + alpha * q(k,j,i) ) / ( 1.0_wp + alpha * q_s )
+
+       IF ( .NOT. microphysics_ice_extension ) THEN
+          IF ( microphysics_seifert ) THEN
+             sat = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
+          ELSEIF ( microphysics_morrison_no_rain ) THEN
+             sat = ( q(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
+          ENDIF
+       ELSE
+          IF ( microphysics_seifert ) THEN
+             sat = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) - qi(k,j,i) ) / q_s - 1.0_wp
+          ELSEIF ( microphysics_morrison_no_rain ) THEN
+             sat = ( q(k,j,i) - qc(k,j,i) - qi(k,j,i) ) / q_s - 1.0_wp
+          ENDIF
+       ENDIF
+
+    END SUBROUTINE supersaturation
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Computation of the diagnostic supersaturation sat, actual liquid water
+!< temperature t_l and saturation water vapor mixing ratio q_s
+!------------------------------------------------------------------------------!
+    SUBROUTINE supersaturation_ice ( i, j, k )
+
+       INTEGER(iwp) ::  i   !< running index
+       INTEGER(iwp) ::  j   !< running index
+       INTEGER(iwp) ::  k   !< running index
+
+       REAL(wp) ::  e_a     !< water vapor pressure
+       REAL(wp) ::  temp    !< actual temperature
+!
+!--    Actual liquid water temperature:
+       t_l = exner(k) * pt(k,j,i)
+!
+!--    Actual temperature:
+       temp = t_l + lv_d_cp * ql(k,j,i) + ls_d_cp * qi(k,j,i)
+!
+!--    Calculate water vapor saturation pressure with formular using actual
+!--    temperature
+       e_si = magnus_ice( temp )
+!
+!--    Computation of ice saturation mixing ratio:
+       q_si = rd_d_rv * e_si / ( hyp(k) - e_si )
+!
+!--    Current vapor pressure
+       e_a = (   q(k,j,i) - qr(k,j,i) - qc(k,j,i) - qi(k,j,i) ) * hyp(k) /     &
+             ( ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) - qi(k,j,i) ) + rd_d_rv )
 !
 !--    Supersaturation:
 !--    Not in case of microphysics_kessler or microphysics_sat_adjust
 !--    since qr is unallocated
-       IF ( microphysics_seifert ) THEN
-          sat = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
-       ELSEIF ( microphysics_morrison_no_rain ) THEN
-          sat = ( q(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
-       ENDIF
-
-    END SUBROUTINE supersaturation
+       sat_ice = e_a / e_si - 1.0_wp
+
+    END SUBROUTINE supersaturation_ice
 
 
@@ -5224,8 +6511,4 @@
     SUBROUTINE calc_liquid_water_content
 
-
-
-       IMPLICIT NONE
-
        INTEGER(iwp) ::  i !<
        INTEGER(iwp) ::  j !<
@@ -5234,5 +6517,4 @@
        REAL(wp)     ::  flag !< flag to indicate first grid level above surface
 
-
        DO  i = nxlg, nxrg
           DO  j = nysg, nyng
@@ -5241,32 +6523,77 @@
 !--             Predetermine flag to mask topography
                 flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
-
 !
 !--             Call calculation of supersaturation located
                 CALL supersaturation( i, j, k )
-
 !
 !--             Compute the liquid water content
-                IF ( microphysics_seifert  .AND. .NOT. microphysics_morrison ) &
-                THEN
-                   IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0_wp )  THEN
-                      qc(k,j,i) = ( q(k,j,i) - q_s - qr(k,j,i) ) * flag
-                      ql(k,j,i) = ( qc(k,j,i) + qr(k,j,i) ) * flag
+                IF ( .NOT. microphysics_ice_extension ) THEN
+                   IF ( microphysics_seifert  .AND. .NOT.                      &
+                        microphysics_morrison )  THEN
+!--                   Seifert and Beheng scheme: saturation adjustment
+                      IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0_wp )  THEN
+                         qc(k,j,i) = ( q(k,j,i) - q_s - qr(k,j,i) ) * flag
+                         ql(k,j,i) = ( qc(k,j,i) + qr(k,j,i) ) * flag
+                      ELSE
+                         IF ( q(k,j,i) < qr(k,j,i) )  q(k,j,i) = qr(k,j,i)
+                         qc(k,j,i) = 0.0_wp
+                         ql(k,j,i) = qr(k,j,i) * flag
+                      ENDIF
+!
+!--                Morrison scheme: explicit condensation (see above)
+                   ELSEIF ( microphysics_morrison  .AND.                       &
+                            microphysics_seifert )  THEN
+                      ql(k,j,i) = qc(k,j,i) + qr(k,j,i) * flag
+!--                Morrison without rain: explicit condensation
+                   ELSEIF ( microphysics_morrison  .AND.                       &
+                            .NOT. microphysics_seifert )  THEN
+                      ql(k,j,i) = qc(k,j,i)
+!--                Kessler and saturation adjustment scheme
                    ELSE
-                      IF ( q(k,j,i) < qr(k,j,i) )  q(k,j,i) = qr(k,j,i)
-                      qc(k,j,i) = 0.0_wp
-                      ql(k,j,i) = qr(k,j,i) * flag
+                      IF ( ( q(k,j,i) - q_s ) > 0.0_wp )  THEN
+                         qc(k,j,i) = ( q(k,j,i) - q_s ) * flag
+                         ql(k,j,i) = qc(k,j,i) * flag
+                      ELSE
+                         qc(k,j,i) = 0.0_wp
+                         ql(k,j,i) = 0.0_wp
+                      ENDIF
                    ENDIF
-                ELSEIF ( microphysics_morrison  .AND.  microphysics_seifert )  THEN
-                   ql(k,j,i) = qc(k,j,i) + qr(k,j,i) * flag
-                ELSEIF ( microphysics_morrison  .AND.  .NOT. microphysics_seifert )  THEN
-                   ql(k,j,i) = qc(k,j,i)                    
+!--             Calculations of liquid water content in case of mixed-phase
+!--             cloud microphyics
                 ELSE
-                   IF ( ( q(k,j,i) - q_s ) > 0.0_wp )  THEN
-                      qc(k,j,i) = ( q(k,j,i) - q_s ) * flag
-                      ql(k,j,i) = qc(k,j,i) * flag
+                   IF ( microphysics_seifert  .AND.                            &
+                        .NOT. microphysics_morrison ) &
+                   THEN
+!
+!--                   Seifert and Beheng scheme: saturation adjustment
+                      IF ( ( q(k,j,i)                                          &
+                             - q_s - qr(k,j,i) - qi(k,j,i) ) > 0.0_wp )  THEN
+                         qc(k,j,i) = ( q(k,j,i) - q_s - qr(k,j,i) - qi(k,j,i) )&
+                                       * flag
+                         ql(k,j,i) = ( qc(k,j,i) + qr(k,j,i) ) * flag
+                      ELSE
+                         IF ( q(k,j,i) < ( qr(k,j,i) + qi(k,j,i) ) )  THEN
+                            q(k,j,i) = qr(k,j,i) + qi(k,j,i)
+                         ENDIF
+                         qc(k,j,i) = 0.0_wp
+                         ql(k,j,i) = qr(k,j,i) * flag
+                      ENDIF
+!--                Morrison scheme: explicit condensation (see above)
+                   ELSEIF ( microphysics_morrison  .AND.                       &
+                            microphysics_seifert )  THEN
+                      ql(k,j,i) = qc(k,j,i) + qr(k,j,i) * flag
+!--                Morrison without rain: explicit condensation
+                   ELSEIF ( microphysics_morrison  .AND.                       &
+                            .NOT. microphysics_seifert )  THEN
+                      ql(k,j,i) = qc(k,j,i)
+!--                Kessler and saturation adjustment scheme
                    ELSE
-                      qc(k,j,i) = 0.0_wp
-                      ql(k,j,i) = 0.0_wp
+                      IF ( ( q(k,j,i) - q_s ) > 0.0_wp )  THEN
+                         qc(k,j,i) = ( q(k,j,i) - q_s ) * flag
+                         ql(k,j,i) = qc(k,j,i) * flag
+                      ELSE
+                         qc(k,j,i) = 0.0_wp
+                         ql(k,j,i) = 0.0_wp
+                      ENDIF
                    ENDIF
                 ENDIF
Index: palm/trunk/SOURCE/compute_vpt.f90
===================================================================
--- palm/trunk/SOURCE/compute_vpt.f90	(revision 4501)
+++ palm/trunk/SOURCE/compute_vpt.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -42,8 +45,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  pt, q, ql, vpt, d_exner
+        ONLY:  pt, q, ql, vpt, d_exner, qi
 
     USE basic_constants_and_equations_mod,                                     &
-        ONLY:  lv_d_cp
+        ONLY:  lv_d_cp, ls_d_cp
 
     USE control_parameters,                                                    &
@@ -56,5 +59,5 @@
 
     USE bulk_cloud_model_mod,                                                  &
-        ONLY:  bulk_cloud_model
+        ONLY:  bulk_cloud_model, microphysics_ice_extension
 
     IMPLICIT NONE
@@ -64,8 +67,15 @@
     IF ( .NOT. bulk_cloud_model  .AND.  .NOT. cloud_droplets )  THEN
        vpt = pt * ( 1.0_wp + 0.61_wp * q )
-    ELSE IF (bulk_cloud_model)  THEN
+    ELSEIF ( bulk_cloud_model  .AND.  .NOT. microphysics_ice_extension )  THEN
        DO  k = nzb, nzt+1
-          vpt(k,:,:) = ( pt(k,:,:) + d_exner(k) * lv_d_cp * ql(k,:,:) ) *      &
-                       ( 1.0_wp + 0.61_wp * q(k,:,:) - 1.61_wp * ql(k,:,:) ) 
+              vpt(k,:,:) = ( pt(k,:,:) + d_exner(k) * lv_d_cp * ql(k,:,:) ) *  &
+                       ( 1.0_wp + 0.61_wp * q(k,:,:) - 1.61_wp *  ql(k,:,:)  )
+       ENDDO
+    ELSEIF ( bulk_cloud_model  .AND.  microphysics_ice_extension ) THEN
+       DO  k = nzb, nzt+1
+          vpt(k,:,:) = ( pt(k,:,:) + d_exner(k) * lv_d_cp * ql(k,:,:)   +      &
+                                     d_exner(k) * ls_d_cp * qi(k,:,:) ) *      &
+                       ( 1.0_wp + 0.61_wp * q(k,:,:) - 1.61_wp          *      &
+                                           ( ql(k,:,:) + qi(k,:,:) ) )
        ENDDO
     ELSE
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4501)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4472 2020-03-24 12:21:00Z Giersch
 ! Calculations of the Kolmogorov lengt scale eta implemented
 !
@@ -84,6 +87,6 @@
     USE arrays_3d,                                                             &
         ONLY:  ddzu, ddzw, e, heatflux_output_conversion, hyp, km, kh,         &
-               momentumflux_output_conversion, nc, nr, p, prho, prr, pt, q,    &
-               qc, ql, qr, rho_air, rho_air_zw, rho_ocean, s,                  &
+               momentumflux_output_conversion, nc, ni, nr, p, prho, prr, pt, q,&
+               qc, qi, ql, qr, rho_air, rho_air_zw, rho_ocean, s,              &
                sa, u, ug, v, vg, vpt, w, w_subs, waterflux_output_conversion,  &
                zw, d_exner
@@ -93,5 +96,6 @@
 
     USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert,   &
+              microphysics_ice_extension
 
     USE chem_modules,                                                          &
@@ -1414,4 +1418,13 @@
                                                                 flag
                          ENDIF
+                         IF ( microphysics_ice_extension )  THEN
+                            sums_l(k,124,tn) = sums_l(k,124,tn) + ni(k,j,i) *  &
+                                                                rmask(j,i,sr) *&
+                                                                flag
+                            sums_l(k,125,tn) = sums_l(k,125,tn) + qi(k,j,i) *  &
+                                                                rmask(j,i,sr) *&
+                                                                flag
+                         ENDIF
+
                          IF ( microphysics_seifert )  THEN
                             sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) *    &
@@ -1915,5 +1928,5 @@
              sums(k,116)           = sums(k,116)           / ngp_2dh_s_inner(k,sr)
              sums(k,118:pr_palm-2) = sums(k,118:pr_palm-2) / ngp_2dh_s_inner(k,sr)
-             sums(k,123)           = sums(k,123) * ngp_2dh_s_inner(k,sr)  / ngp_2dh(sr)
+             sums(k,123:125)       = sums(k,123:125) * ngp_2dh_s_inner(k,sr)  / ngp_2dh(sr)
           ENDIF
        ENDDO
@@ -2029,4 +2042,6 @@
        hom(:,1,72,sr) = hyp * 1E-2_wp  ! hyp in hPa
        hom(:,1,123,sr) = sums(:,123)   ! nc
+       hom(:,1,124,sr) = sums(:,124)   ! ni
+       hom(:,1,125,sr) = sums(:,125)   ! qi
        hom(:,1,73,sr) = sums(:,73)     ! nr
        hom(:,1,74,sr) = sums(:,74)     ! qr
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 4501)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 4502)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of ice microphysics
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -58,5 +61,6 @@
 
     USE bulk_cloud_model_mod,                                                  &
-        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert,   &
+              microphysics_ice_extension
 
     USE control_parameters,                                                    &
@@ -268,4 +272,16 @@
                 unit = '1/m3'
 
+             CASE ( 'ni' )
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   WRITE ( message_string, * ) 'output of "', TRIM( var ),     &
+                        '" requires bulk_cloud_model = .TRUE.'
+                   CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
+                 ELSEIF ( .NOT. microphysics_ice_extension ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                         'requires  microphysics_ice_extension = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
+                ENDIF
+                unit = '1/m3'
+
              CASE ( 'nr' )
                 IF ( .NOT. bulk_cloud_model )  THEN
@@ -331,4 +347,16 @@
                         '" requires bulk_cloud_model = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
+                ENDIF
+                unit = 'kg/kg'
+
+             CASE ( 'qi' )
+                IF ( .NOT. bulk_cloud_model )  THEN
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                            'requires bulk_cloud_model = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
+                ELSEIF ( .NOT. microphysics_ice_extension ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" ' //    &
+                            'requires microphysics_ice_extension = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
                 unit = 'kg/kg'
